"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filterDiffJson = filterDiffJson;
exports.filterReportBasedBranchDiff = filterReportBasedBranchDiff;
var _path = _interopRequireDefault(require("path"));
var _getModifiedLines = require("../getModifiedLines");
var _getFileUtils = require("./getFileUtils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function filterReportBasedBranchDiff(reportJson, diffJson) {
  return new Promise(function (resolve) {
    if (!diffJson) {
      Logger.log(Logger.FAILURE_TYPE, "git diff json is not given ...");
      resolve(false);
    }
    var impactLineMap = filterDiffJson(diffJson);
    reportJson = reportJson.filter(function (fileReport) {
      var _impactLineMap$get;
      var isImpactFile = fileReport.filePath;
      if (!isImpactFile || isImpactFile.includes(".feature")) {
        return false;
      }
      if (((_impactLineMap$get = impactLineMap.get(isImpactFile)) === null || _impactLineMap$get === void 0 ? void 0 : _impactLineMap$get.length) !== 0) {
        fileReport.messages = fileReport.messages.filter(function (errorMsg) {
          if (impactLineMap.get(isImpactFile).includes(errorMsg.line)) {
            return true;
          }
          return false;
        });
        return true;
      }
    });
    resolve(reportJson);
  });
}
function filterDiffJson(diffJson) {
  var _diffJson$diffs;
  var diffFilesMap = new Map();
  diffJson === null || diffJson === void 0 || (_diffJson$diffs = diffJson.diffs) === null || _diffJson$diffs === void 0 || _diffJson$diffs.forEach(function (diff) {
    var diffPathKey = _path["default"].resolve((0, _getFileUtils.getRootGitPath)(), diff.new_path);
    if (diffPathKey === undefined) {
      return;
    }
    if (diffPathKey) {
      diffFilesMap.set(diffPathKey, (0, _getModifiedLines.getModifiedLines)(diff.diff).modifiedLines);
    }
  });
  return diffFilesMap;
}