import { leftPanelAssertion, rightPanelAssertion } from "..";
import { TICKET_SELECTORS, getAsDataId, setLocalStorage } from "../dom-selectors/TicketDvSelectors";

export default function TicketDetailView(defaultProps) {
    return {
        ...defaultProps,
        async openConversation(){
            await this.page.getByTestId('CaseResolution_Tab').click();
            await this.page.getByTestId('CaseConversations_Tab').click();
        },
        async openRecentThread(){
            // await this.page.waitForTimeout(5000)
            // await this.page.waitForSelector(getAsDataId('ThreadDiscrip'), {state:'visible'});
            await this.page.getByTestId(`${TICKET_SELECTORS.THREAD_DISCRIP}`).first().click();
        },
        async verifyAssignedAgent(agentName){
            const leftPanel = leftPanelAssertion(this.page)
            await leftPanel.verifyAssignedAgent(agentName)
        },
        async openRecipients() {
            const thread = await this.page.getByTestId(
            `${TICKET_SELECTORS.THREAD_DISCRIP}`
            ).first();
            setLocalStorage('threadId', await thread.getAttribute('id'))
            const toggleRecipientsId = await thread.locator('[data-id^="toggleRecipients"]').getAttribute("data-id")
            if (toggleRecipientsId == 'toggleRecipients') {
              await thread.hover();
              await thread.locator(TICKET_SELECTORS.TOGGLE_RECIPIENTS).click();
            }
        },
        async validateThreadTos(toArr){
            const rightPanel = rightPanelAssertion(this.page)
            for(let i=0;i<toArr.length;i++){
                await rightPanel.validateThreadTos(toArr[i])
            }
            
        },
        async validateThreadCcs(ccArr){
            const rightPanel = rightPanelAssertion(this.page)
            for(let i=0;i<ccArr.length;i++){
                await rightPanel.validateThreadCcs(ccArr[i])
            }
            
        },
        async validateThreadCount(count){
            const rightPanel = rightPanelAssertion(this.page)
            await rightPanel.validateThreadCount(count)
        },
        async waitForTDVSubjectLoad(){
            await this.page.waitForSelector(getAsDataId(TICKET_SELECTORS.TICKET_SUBJECT))
        }
    }
    
}
