import path from'path'
import { spawnSync } from 'child_process'
function getFilesFromBranchDiff(diffJson) {
    if (!diffJson) {
      return null;
    }
    const rootPath = getRootGitPath();
    return diffJson?.diffs.map((diff) => {
      return path.resolve(rootPath, diff?.new_path);
    });
  }
  
  function getLintReportPath(reportPath) {
    let jsonReportPath = reportPath || path.resolve(process.cwd(), "uat", "lint-report", "lintReport.json");
    return jsonReportPath;
  }
  
  function resolveBranchDiffPath(diffJsonPath) {
    return path.resolve(diffJsonPath);
  }
  
  function getStagedFiles() {
    const command = "git diff --cached -U0 HEAD --name-only";
    const child = spawnSync(command, { shell: true });
    const diffFiles = child.stdout
      .toString()
      .split("\n")
      .map((filePath) => path.resolve(getRootGitPath(), filePath));
    diffFiles.pop(); // remove last empty string
    return diffFiles;
  }
  
  function getRootGitPath() {
    const childProcess = spawnSync("git", ["rev-parse", "--show-toplevel"], {shell: true,});
    return childProcess.stdout.toString().split("\n").filter(Boolean).pop();
  }



  export {
    getFilesFromBranchDiff,
    getRootGitPath,
    getLintReportPath,
    getStagedFiles,
    resolveBranchDiffPath
  }