const { Logger } = require("../utils/logger");

function getModifiedLines(content) {
    const modifiedLines = [];
    const removedLines = [];
  
    try {
      const diffLineContentIter = content.split('\n');
      let addLineFrom = -1;
      let removeLineFrom = -1;
      let affectedLineNum = 0;
  
      for (const currentDiffLine of diffLineContentIter) {
        if (currentDiffLine.startsWith('@')) {
          const lineNos = currentDiffLine.split('@@')[1].trim().split(' ');
          const removedLineDetail = lineNos[0].replace(/-/g, '').split(',');
          const addedLineDetail = lineNos[1].replace(/\+/g, '').split(',');
  
          addLineFrom = parseInt(addedLineDetail[0]);
          removeLineFrom = parseInt(removedLineDetail[0]);
          affectedLineNum = removeLineFrom;
  
          continue;
        }
  
        if (currentDiffLine.startsWith('+') || currentDiffLine.startsWith('-')) {
          const isLineChanged = currentDiffLine.trim().length > 1;
  
          if (isLineChanged) {
            modifiedLines.push(affectedLineNum);
          }
  
          if (currentDiffLine.startsWith('-')) {
            removedLines.push(affectedLineNum);
          }
  
          if (!currentDiffLine.startsWith('-')) {
            affectedLineNum++;
          }
        }
      }
    } catch (exp) {
       Logger.log(Logger.FAILURE_TYPE,`Exception Occurred: ${exp}`);
    }
  
    return { modifiedLines, removedLines };
  }

  
  module.exports = {
    getModifiedLines
  }